/*:
The following code produces compile error **"generic parameter 'T' could not be inferred"** at the final line of this playground.

The error is gone when conformance to `MediaProtocol` is removed from the generic type `T` at the `process` method declaration:

```` func process<T>(item: T) -> T ````
*/
protocol MediaProtocol {}
protocol ImageProtocol: MediaProtocol {}

class Image: ImageProtocol {}

func itemToProcess() -> ImageProtocol {
    return Image()
}

//func process<T>(item: T) -> T { // Uncomment this line and comment out the following one to remove the compile-time error
func process<T: MediaProtocol>(item: T) -> T {
    return item
}

let image = itemToProcess()
let processedImage: ImageProtocol = process(image)
